#ifndef glas_concept_is_vector_collection_hpp
#define glas_concept_is_vector_collection_hpp

#include <glas/concept/template_for_is.hpp>
#include <glas/concept/vector_collection_concept.hpp>
#include <boost/mpl/or.hpp>
#include <boost/mpl/if.hpp>
#include <boost/mpl/bool.hpp>
#include <boost/mpl/front.hpp>
#include <boost/mpl/pop_front.hpp>
#include <boost/mpl/empty.hpp>

namespace glas {

  namespace detail {

    template <class T>
    struct is_vector_collection_aux
    : template_for_is< T, is_vector_collection_aux >
    {} ;

    template <>
    struct is_vector_collection_aux< vector_collection_concept >
    : boost::mpl::true_
    {} ;

  } // namespace detail


  template <class T>
  struct is_vector_collection
  : detail::is_vector_collection_aux< typename concept< T >::type >
  {} ;

}

#endif
